from mpython import *
import printer_servo as servo
import printer_gui_menu as menu
import printer_gui as gui
import printer_stepper as stepper
import printer_file_system as fil
import os
import math
import utime
import printer_input as inpt
import config as cfg
import framebuf
import logging

tl = logging.getLogger("core")


class print_data_struct:
    def __init__(self):
        self.printing_x_number = 0
        self.printing_y_number = 0
        self.start_time = 0
        self.finish_time = 0
        self.print_time = 0


print_data = print_data_struct()


def print_hex_file(file_path):
    global print_data, arm_servo
    fil.file = fil.file_struct(file_path)
    if not gui.print_content_confirm(file_path):
        return
    oled.fill(0)
    gui.auto_show_text(1, "正  在  打  印")
    gui.screen_fresh_percent(0)
    print_data.start_time = utime.ticks_ms()
    oled.show()
    stepper.stepper.normal_mode()
    """
    打印核心
    """
    for print_data.printing_x_number in range(fil.file.width):
        tl.debug("=====start new col %d=====", print_data.printing_x_number)
        servo.arm.move(servo.arm.current_step, delay=False)
        time.sleep_ms(servo.arm.steps_delay)
        for print_data.printing_y_number in range(fil.file.height):
            if (
                fil.file.frame_buffer.pixel(
                    print_data.printing_x_number, print_data.printing_y_number
                )
                == 0
            ):
                continue
            tl.debug(
                "print:%d,%d",
                print_data.printing_x_number,
                print_data.printing_y_number,
            )
            servo.arm.move(print_data.printing_y_number)
            servo.dot.dot_once(print_data.printing_y_number)
        if print_data.printing_x_number == fil.file.width - 1:
            tl.debug("file last col")
            stepper.stepper.steps()
            gui.screen_fresh_percent(100)
            continue
        for predict_y_number in range(fil.file.height):
            if not (
                fil.file.frame_buffer.pixel(
                    print_data.printing_x_number + 1, predict_y_number
                )
                == 1
            ):
                continue
            tl.debug(
                "predict:%d,%d", print_data.printing_x_number + 1, predict_y_number
            )
            """
            if arm_servo.current_step == predict_y_number:
                break
            """
            servo.arm.move(predict_y_number, delay=False)
            break
        stepper.stepper.steps()
        gui.screen_fresh_percent(print_data.printing_x_number / fil.file.width * 100)
    """
    打印核心结束
    """
    stepper.stepper.fast_mode()
    print_data.finish_time = utime.ticks_ms()
    tl.info("print finish")
    oled.fill(0)
    gui.auto_show_text(1, "打  印  完  成")
    print_data.print_time = round(
        (print_data.finish_time - print_data.start_time) / 1000
    )
    print_time_text = (
        "耗时："
        + str(gui.convert_time(print_data.print_time)[1])
        + "分"
        + str(gui.convert_time(print_data.print_time)[2])
        + "秒"
    )
    tl.info("time:%s", print_time_text)
    gui.auto_show_text(2, print_time_text)
    servo.dot.dot(False)
    servo.arm.move(-1)
    stepper.stepper.steps()
