from mpython import *
import printer_global_variable as glovar

import logging

tl = logging.getLogger("input")

tl.debug("importing input")

tl = logging.getLogger("init_core")
tl.info("detecting firmware type...")
try:
    a = button_a
    b = button_b
    p = touchpad_p
    y = touchpad_y
    t = touchpad_t
    h = touchpad_h
    o = touchpad_o
    n = touchpad_n
    tl.info("labplus firmware detected")
except:
    tl.debug("dfrobot firmware detected")
    a = button_a
    b = button_b
    p = touchPad_P
    y = touchPad_Y
    t = touchPad_T
    h = touchPad_H
    o = touchPad_O
    n = touchPad_N

tl = logging.getLogger("input")
tl.debug("button defined")

key_array = [a, b, p, y, t, h, o, n]


def is_pressed(key_name, wait_press=False):
    if key_name == a or key_name == b:
        if not key_name.value() == 0:
            return False
        if not wait_press:
            return True
        while key_name.value() == 0:
            pass
        return True
    if key_name.read() < glovar.touchpad_trigger_value:
        if not wait_press:
            return True
        while key_name.read() < glovar.touchpad_trigger_value:
            pass
        return True
    return False


def is_pressed_short(key_name):
    if not is_pressed(key_name):
        return False
    while is_pressed(key_name):
        pass
    return True


def anykey_pressed(wait_press=False):
    for this_key in key_array:
        if is_pressed(this_key, wait_press):
            return True
    return False


def key_array_state(key_array):
    for i in key_array:
        if is_pressed(i):
            return True
    return False
